' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : K.Yakushinji
'
'  : 2007/02/01 
' -----------------------------------------------------------------
Imports FVDATASLib

Public Class frmMain

    'ő働bN
    Private Const MAX_LOCK As Integer = 16

    'DisplayEx
    Private Const DISPEX_CNT As Integer = 4

    'FvxImagȅi[\
    Private Structure ImgInfo
        Friend bUsed As Boolean     'gptO
        Friend iHandle As Integer   'nh
        Friend iNum As Integer      'Image
        Friend bImgCh() As Boolean  '(0)Gray0 (1)Gray1 (2)Bin0 (3)Bin1
    End Structure

    Const FVC05_LOCAL_BUFFER_SIZE As Long = 16777216    '16MB
    Const CONST_BUFF_BOUNDARY As Long = &H40000         '256K FBufConfig̃g[^TCY߂̂Ɏgp
    Const CONST_BUFF_MASK As Long = &H3FFFF             '256K-1 FBufConfig̃g[^TCY߂̂Ɏgp

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'rfIݒt@CitpXj
    Private m_strVideoConfFilePath As String

    'HWQl\ǂ
    Private m_blnCanHWBinarize As Boolean

    'FvxImage CX^X
    Private m_FvxImages(MAX_LOCK, 4) As FVXCOMIMAGELib.FvxImage

    'FvxDisplayEx CX^X
    Private m_AxFvxDisplayEx_CH(DISPEX_CNT) As AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
    Private m_AxFvxDisplayEx_ALL(DISPEX_CNT) As AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx

    'LockĂ
    Private m_ImgInfo(MAX_LOCK) As ImgInfo

    'A荞ݒǂ
    Private m_bIsContinuous As Boolean

    'A荞ݒ̉摜ԍ
    Private m_nIndexNo As Integer
    Private m_nLastNo As Integer
    Private m_nDispNo As Integer

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim i As Integer, j As Integer

        'rfIfoCX̃I[vԕێϐ̏
        m_blnVideoOpened = False
        m_bIsContinuous = False

        'ϐFvxDisplayExZbg
        m_AxFvxDisplayEx_CH(0) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_CH(0) = AxFvxDisplayEx_CH0
        m_AxFvxDisplayEx_CH(1) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_CH(1) = AxFvxDisplayEx_CH1
        m_AxFvxDisplayEx_CH(2) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_CH(2) = AxFvxDisplayEx_CH2
        m_AxFvxDisplayEx_CH(3) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_CH(3) = AxFvxDisplayEx_CH3
        m_AxFvxDisplayEx_ALL(0) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_ALL(0) = AxFvxDisplayEx_All0
        m_AxFvxDisplayEx_ALL(1) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_ALL(1) = AxFvxDisplayEx_All1
        m_AxFvxDisplayEx_ALL(2) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_ALL(2) = AxFvxDisplayEx_All2
        m_AxFvxDisplayEx_ALL(3) = New AxFVXCOMDISPLAYEXLib.AxFvxDisplayEx
        m_AxFvxDisplayEx_ALL(3) = AxFvxDisplayEx_All3

        '
        For i = 0 To MAX_LOCK - 1
            For j = 0 To 4 - 1
                m_FvxImages(i, j) = New FVXCOMIMAGELib.FvxImage
            Next j
            ReDim m_ImgInfo(i).bImgCh(4)
            fnInitImgInfo(i)
        Next i

        'ʂ̐
        For i = 0 To DISPEX_CNT - 1
            m_AxFvxDisplayEx_CH(i).CreateDisplay()
            m_AxFvxDisplayEx_ALL(i).CreateDisplay()
        Next i

        'gp̊mF
        If My.Forms.frmLicence.ShowDialog() <> Windows.Forms.DialogResult.Yes Then
            End
        End If

        'rfIfoCXI
        setVideoConfFile()

    End Sub

    'Jݒt@C̐ݒ
    Private Sub setVideoConfFile()

        Dim intCaptureType As Integer
        Dim i As Integer, j As Integer
        Dim nFBufChannel As Integer, nFBufNum As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile  'rfIݒt@C

        If m_blnVideoOpened = True Then
            'rfIfoCXI[vĂꍇ͈UN[Y܂
            AxFvxVideo1.CloseDevice()

            'o^Ă摜NA
            gridImageData.Rows.Clear()
            For i = 0 To MAX_LOCK - 1
                fnInitImgInfo(i)
            Next i

            'I[vtO𗎂
            m_blnVideoOpened = False

        End If

        'rfIݒt@C̑I
        m_strVideoConfFilePath = ""
        If frmVideoConf.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
        End If

        Try
            If m_strVideoConfFilePath.Length <> 0 Then

                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath
                'foCXI[v
                AxFvxVideo1.OpenDevice()

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                '̂߁AZbgAbv^CKvɂȂ܂
                Threading.Thread.Sleep(200)

                'Lv`{[h^Cv擾
                AxFvxVideo1.GetCaptureType(intCaptureType)
                If 7 = intCaptureType Then

                    'rfIfoCX̏ԂL
                    m_blnVideoOpened = True
                    btn1Shot.Enabled = True
                    btnContinuousGrabEx.Enabled = True

                    'HWQl
                    m_blnCanHWBinarize = True
                    grpHW.Enabled = True
                    AxFvxVideo1.GetBinarizeThreshold(i)
                    trcBinLevel.Value = i
                    txtBinLevel.Text = i
                    txtBinLevel.Enabled = True
                    trcBinLevel.Enabled = True

                    'rfIItZbg
                    AxFvxVideo1.GetVideoOffset(i)
                    trcOffSet.Value = i
                    txtOffset.Text = i

                    'FV1100/FVC05̂݃rfIItZbg-512`511
                    trcOffSet.Minimum = -512
                    trcOffSet.Maximum = 511
                    lbVideoOffsetMin.Text = -512
                    lbVideoOffsetMax.Text = 511

                    'FBufConfig
                    AxFvxVideo1.GetFBufConfig(nFBufChannel, nFBufNum)
                    Dim cTemp As New CheckBox
                    For i = 0 To 4 - 1
                        cTemp = Me.grpParam.Controls("chkInputChannel" + i.ToString)
                        If (0 <> ((nFBufChannel And (2 ^ (3 - i))))) Then
                            cTemp.Checked = True
                        Else
                            cTemp.Checked = False
                        End If
                    Next i

                    '摜TCY̕ύX
                    For j = 0 To MAX_LOCK - 1
                        For i = 0 To 4 - 1
                            AxFvxVideo1.ChangeImageSize(m_FvxImages(j, i))
                            m_FvxImages(j, i).ImageNum = 1
                            If (2 = i) Or (3 = i) Then
                                m_FvxImages(j, i).BitPerPixel = 1
                            End If
                        Next i
                    Next j

                    fnButtonEnable(True)
                    fn4DispFullScale()

                Else
                    MsgBox("FVC05ΉĂ܂BLv`{[hN[Y܂", vbExclamation, "G[")
                    AxFvxVideo1.CloseDevice()
                    fnButtonEnable(False)
                End If

            Else
                fnButtonEnable(False)
            End If

        Catch

            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
            fnButtonEnable(False)
        Finally
            '--------------------------------------------
        End Try

    End Sub

    'Sʓ\̃XP[ύX
    Private Sub fn4DispFullScale()

        Dim i As Long
        Dim dblScaleX As Double
        Dim dblScaleY As Double
        Dim dblSetVal As Double

        Dim pSize As New FvSize

        If m_blnVideoOpened = True Then
            AxFvxVideo1.GetCaptureSize(pSize)

            dblScaleX = m_AxFvxDisplayEx_ALL(0).Size.Width / pSize.x
            dblScaleY = m_AxFvxDisplayEx_ALL(0).Size.Height / pSize.y

            If dblScaleX < dblScaleY Then
                dblSetVal = dblScaleX
            Else
                dblSetVal = dblScaleY
            End If

            For i = 0 To 4 - 1
                m_AxFvxDisplayEx_ALL(i).Magnification = dblSetVal
            Next i
        End If

    End Sub

    'ButtonEnableݒ
    Private Function fnButtonEnable(ByVal bEnable As Boolean) As Integer

        btn1Shot.Enabled = bEnable
        'btnContinuousGrabEx.Enabled = bEnable
        udNum.Enabled = bEnable
        grpParam.Enabled = bEnable
        grpOffset.Enabled = bEnable
        grpHW.Enabled = bEnable
        fnButtonEnable = 0

    End Function


    '摜\̂̏
    Private Function fnInitImgInfo(ByVal no As Long) As Long

        m_ImgInfo(no).bUsed = False
        m_ImgInfo(no).iHandle = &HFFFFFFFF
        m_ImgInfo(no).iNum = 0
        m_ImgInfo(no).bImgCh(0) = False
        m_ImgInfo(no).bImgCh(1) = False
        m_ImgInfo(no).bImgCh(2) = False
        m_ImgInfo(no).bImgCh(3) = False
        fnInitImgInfo = 0

    End Function

    'FvxVideoG[bZ[W擾
    Private Function GetFvxVideoErrMsg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 6001
                GetFvxVideoErrMsg = "\ȂG[łB"
            Case 6002
                GetFvxVideoErrMsg = "T|[gĂ܂B"
            Case 6005
                GetFvxVideoErrMsg = "p[^słB"
            Case 6010
                GetFvxVideoErrMsg = "̊mۂɎs܂B"
            Case 6015
                GetFvxVideoErrMsg = "DLLt@C݂܂B"
            Case 6020
                GetFvxVideoErrMsg = "foCX̃I[vɎs܂B"
            Case 6021
                GetFvxVideoErrMsg = "ɃI[vĂ܂B"
            Case 6030
                GetFvxVideoErrMsg = "Lv`I[vĂ܂B"
            Case 6031
                GetFvxVideoErrMsg = "Lv`{[h܂B"
            Case 6032
                GetFvxVideoErrMsg = "foCXIDsłB"
            Case 6037
                GetFvxVideoErrMsg = "GrabASynĉߏs܂B"
            Case 6040
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case 6041
                GetFvxVideoErrMsg = "^CAEg܂B"
            Case 6042
                GetFvxVideoErrMsg = "摜f[^słB"
            Case 6043
                GetFvxVideoErrMsg = "摜͂Ɏs܂B"
            Case 6044
                GetFvxVideoErrMsg = "Xe[^X`FbNɎs܂B"
            Case 6045
                GetFvxVideoErrMsg = "ݒ肵摜TCYvĂȂAWOIEBhEPݒ肳Ă܂B"
            Case 6046
                GetFvxVideoErrMsg = "摜̃bNɎs܂B"
            Case 6047
                GetFvxVideoErrMsg = "摜̃AbNɎs܂B"
            Case 6048
                GetFvxVideoErrMsg = "nhsłB"
            Case 6052
                GetFvxVideoErrMsg = "[h̕ύXɎs܂B"
            Case 6053
                GetFvxVideoErrMsg = "[h̎擾Ɏs܂B"
            Case 6054
                GetFvxVideoErrMsg = "Lv`TCY̕ύXɎs܂B"
            Case 6055
                GetFvxVideoErrMsg = "摜TCY擾Ɏs܂B"
            Case 6056
                GetFvxVideoErrMsg = "Lv`ItZbgݒɎs܂B"
            Case 6058
                GetFvxVideoErrMsg = "rfIItZbg̐ݒɎs܂B"
            Case 6060
                GetFvxVideoErrMsg = "IԂ̐ݒɎs܂B"
            Case 6061
                GetFvxVideoErrMsg = "IԂ̎擾Ɏs܂B"
            Case 6062
                GetFvxVideoErrMsg = "^CAEg̕ύXɎs܂B"
            Case 6063
                GetFvxVideoErrMsg = "^CAEg擾Ɏs܂B"
            Case 6066
                GetFvxVideoErrMsg = "2lݒɎs܂B"
            Case 6074
                GetFvxVideoErrMsg = "gK[h̕ύXɎs܂B"
            Case 6080
                GetFvxVideoErrMsg = "rfIݒt@C܂B"
            Case 6081
                GetFvxVideoErrMsg = "rfIݒt@CpXݒ肳Ă܂B"
            Case 6085
                GetFvxVideoErrMsg = "JR}ht@C܂B"
            Case 6100
                GetFvxVideoErrMsg = "SIOR}hgpł܂B"
            Case 6101
                GetFvxVideoErrMsg = "SIOR}h܂B"
            Case 6102
                GetFvxVideoErrMsg = "SIO^CAEg܂BJڑĂ邱ƂmFĂB"
            Case 6150
                GetFvxVideoErrMsg = "[Jobt@ȏ̃TCYw肵Ă܂B"
            Case 6200
                GetFvxVideoErrMsg = "JڑĂȂAdĂ܂B"
            Case 6201
                GetFvxVideoErrMsg = "J̏Ɏs܂B"
            Case 6202
                GetFvxVideoErrMsg = "JtbVɎs܂B"
            Case 6203
                GetFvxVideoErrMsg = "JZ[uɎs܂B"
            Case 6204
                GetFvxVideoErrMsg = "J[hɎs܂B"
            Case 6210
                GetFvxVideoErrMsg = "BitWidthݒɎs܂B"
            Case 6211
                GetFvxVideoErrMsg = "Bit擾Ɏs܂B"
            Case 6212
                GetFvxVideoErrMsg = "CC̐ݒɎs܂B"
            Case 6213
                GetFvxVideoErrMsg = "CC̎擾Ɏs܂B"
            Case 6214
                GetFvxVideoErrMsg = "SIO[hݒɎs܂B"
            Case 6216
                GetFvxVideoErrMsg = "SIOp[^̐ݒɎs܂B"
            Case 6217
                GetFvxVideoErrMsg = "SIOp[^̎擾Ɏs܂B"
            Case 6218
                GetFvxVideoErrMsg = "WOIEBhE̐ݒɎs܂B"
            Case 6220
                GetFvxVideoErrMsg = "WOI Enable̐ݒɎs܂B"
            Case 6222
                GetFvxVideoErrMsg = "WOI[h̐ݒɎs܂B"
            Case 6221
                GetFvxVideoErrMsg = "WOI Enable̎擾Ɏs܂B"
            Case 6223
                GetFvxVideoErrMsg = "WOI[h̎擾Ɏs܂B "
            Case 6360
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case Else
                GetFvxVideoErrMsg = "sȃG["
        End Select

    End Function


    Public Sub New()

        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒŏǉ܂B

    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    
    'tabTCYύXꂽƂ̏
    Private Sub tab_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles tab.Resize

        Dim newSize As New Size
        Dim newLocation As New Point

        newSize.Width = (tab.Width - AxFvxDisplayEx_All0.Left - 25) / 2
        newSize.Height = (tab.Height - AxFvxDisplayEx_All0.Top - 50) / 2
        AxFvxDisplayEx_All0.Size = newSize
        AxFvxDisplayEx_All1.Size = newSize
        AxFvxDisplayEx_All2.Size = newSize
        AxFvxDisplayEx_All3.Size = newSize

        newLocation.X = AxFvxDisplayEx_All0.Location.X + AxFvxDisplayEx_All0.Size.Width + 15
        newLocation.Y = AxFvxDisplayEx_All0.Location.Y
        AxFvxDisplayEx_All1.Location = newLocation

        newLocation.X = AxFvxDisplayEx_All0.Location.X
        newLocation.Y = AxFvxDisplayEx_All0.Size.Height + 20
        AxFvxDisplayEx_All2.Location = newLocation

        newLocation.X = AxFvxDisplayEx_All1.Location.X
        newLocation.Y = AxFvxDisplayEx_All2.Location.Y
        AxFvxDisplayEx_All3.Location = newLocation

        fn4DispFullScale()
    End Sub

    '\{minus
    Private Sub btnDispMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispMinus.Click
        m_AxFvxDisplayEx_CH(0).Magnification = m_AxFvxDisplayEx_CH(0).Magnification - 0.5
        m_AxFvxDisplayEx_CH(1).Magnification = m_AxFvxDisplayEx_CH(0).Magnification
        m_AxFvxDisplayEx_CH(2).Magnification = m_AxFvxDisplayEx_CH(0).Magnification
        m_AxFvxDisplayEx_CH(3).Magnification = m_AxFvxDisplayEx_CH(0).Magnification

        If m_AxFvxDisplayEx_CH(0).Magnification <= 0.5 Then
            btnDispMinus.Enabled = False
        Else
            btnDispMinus.Enabled = True
        End If
        btnDispPlus.Enabled = True

    End Sub

    '\{plus
    Private Sub btnDispPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPlus.Click
        m_AxFvxDisplayEx_CH(0).Magnification = m_AxFvxDisplayEx_CH(0).Magnification + 0.5
        m_AxFvxDisplayEx_CH(1).Magnification = m_AxFvxDisplayEx_CH(0).Magnification
        m_AxFvxDisplayEx_CH(2).Magnification = m_AxFvxDisplayEx_CH(0).Magnification
        m_AxFvxDisplayEx_CH(3).Magnification = m_AxFvxDisplayEx_CH(0).Magnification

        If m_AxFvxDisplayEx_CH(0).Magnification > 10.0# Then
            btnDispPlus.Enabled = False
        Else
            btnDispPlus.Enabled = True
        End If
        btnDispMinus.Enabled = True

    End Sub

    Private Sub btnDispx1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispx1.Click

        m_AxFvxDisplayEx_CH(0).Magnification = 1
        m_AxFvxDisplayEx_CH(1).Magnification = 1
        m_AxFvxDisplayEx_CH(2).Magnification = 1
        m_AxFvxDisplayEx_CH(3).Magnification = 1

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'tʕ\
    Private Sub btnDispFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispFull.Click

        Dim dblScaleX As Double
        Dim dblScaleY As Double
        Dim dblSetVal As Double
        Dim i As Integer

        Dim pSize As New FvSize

        If m_blnVideoOpened = True Then

            AxFvxVideo1.GetCaptureSize(pSize)

            ' ch0/1 gray/bin ------------
            dblScaleX = m_AxFvxDisplayEx_CH(0).Width / pSize.x
            dblScaleY = m_AxFvxDisplayEx_CH(0).Height / pSize.y

            If dblScaleX < dblScaleY Then
                dblSetVal = dblScaleX
            Else
                dblSetVal = dblScaleY
            End If

            For i = 0 To 4 - 1
                m_AxFvxDisplayEx_CH(i).Magnification = dblSetVal
            Next i

            btnDispPlus.Enabled = True
            btnDispMinus.Enabled = True

        End If

    End Sub

    'AScope\؂ւ
    Private Sub chkAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAScope.CheckedChanged

        Dim i As Integer
        If chkAScope.Checked Then
            For i = 0 To 4 - 1
                m_AxFvxDisplayEx_CH(i).AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            Next i
        Else
            For i = 0 To 4 - 1
                m_AxFvxDisplayEx_CH(i).AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            Next i
        End If

    End Sub

    'rfIݒt@C̍Đݒ
    Private Sub btnResetVideoConfFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetVideoConfFile.Click

        'A荞ݒȂ΁A~B
        If m_bIsContinuous Then
            btnContinuousGrabEx_Click(sender, e)
            m_bIsContinuous = 0
            Threading.Thread.Sleep(200)
        End If

        'rfIfoCX̑I
        setVideoConfFile()

    End Sub

    'A荞
    Private Sub btnContinuousGrabEx_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnContinuousGrabEx.Click

        If m_bIsContinuous = False Then
            'A荞݊Jn
            Dim nHandle As Integer
            Dim nCapturenum As Integer
            Try
                nHandle = gridImageData.CurrentRow.Cells(0).Value
            Catch
                MsgBox("摜LockĂ܂B", vbExclamation, "G[")
                Exit Sub
            End Try

            If nHandle >= 1 Then
                '񓯊A荞݊Jn
                nCapturenum = udNum.Value
                AxFvxVideo1.ContinuousGrabEx(nHandle, nCapturenum, True)

                m_nIndexNo = fnFindHandleToIndex(nHandle)
                m_bIsContinuous = True

                fnButtonEnable(False)
                Timer1.Enabled = True
                btnContinuousGrabEx.Text = "A荞ݏI"
            Else
                MsgBox("摜w肳Ă܂B", vbExclamation, "G[")
            End If
        Else
            'A荞݂̏I
            AxFvxVideo1.GrabCancel(0)
            m_bIsContinuous = False

            fnButtonEnable(True)
            Timer1.Enabled = False

            btnContinuousGrabEx.Text = "A荞݊Jn"
        End If

    End Sub

    '摜̕ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = Application.StartupPath
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'Xgr[őIĂA摜ۑ
            '  O̕t́Aaaa.bmpƎw肳ꂽꍇA
            '  aaa_01_0001_ch0G.bmp̂悤ɂȂB
            '  [FileName_HandleNo_ImageCurrent_ChannelNo(GorB).bmp]
            '  IĂ摜ׂĕۑ邽߁A\ȃt@CTCYɂȂ܂
            Try
                Dim strPath1 As String, strPath2 As String, strPath3 As String
                Dim i As Long, j As Long
                Dim nHandle As Integer, nIndex As Integer

                nHandle = gridImageData.CurrentRow.Cells(0).Value
                nIndex = fnFindHandleToIndex(nHandle)


                strPath1 = Mid(SaveFileDialog1.FileName(), 1, SaveFileDialog1.FileName().Length - 4) '".bmp"ăRs[
                strPath1 = strPath1 + nHandle.ToString("_00")
                For i = 0 To m_ImgInfo(nIndex).iNum - 1
                    strPath2 = strPath1 + i.ToString("_0000")
                    For j = 0 To 4 - 1
                        If True = m_ImgInfo(nIndex).bImgCh(j) Then
                            Select Case j
                                Case 0 : strPath3 = strPath2 + "_Ch0G.bmp"
                                Case 1 : strPath3 = strPath2 + "_Ch1G.bmp"
                                Case 2 : strPath3 = strPath2 + "_Ch0B.bmp"
                                Case 3 : strPath3 = strPath2 + "_Ch1B.bmp"
                                Case Else
                                    strPath3 = strPath2 + ".bmp"
                            End Select

                            AxFvxFileAccess1.FilePath = strPath3
                            m_FvxImages(nIndex, j).CurrentNo = i
                            AxFvxFileAccess1.SaveBitmap(m_FvxImages(nIndex, j))
                            m_FvxImages(nIndex, j).CurrentNo = 0
                        End If
                    Next j
                Next i

            Catch
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" + intErr.ToString() + ")", vbExclamation, "ۑs")
            End Try
        End If

    End Sub

    'HandleA摜f[^IndexT
    Private Function fnFindHandleToIndex(ByVal nHandle As Integer) As Integer
        Dim i As Long
        fnFindHandleToIndex = -1
        For i = 0 To MAX_LOCK - 1
            If nHandle = m_ImgInfo(i).iHandle Then
                fnFindHandleToIndex = i
                Exit Function
            End If
        Next i
    End Function

    'rfIItZbgݒ
    Private Sub trcOffSet_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcOffSet.Scroll
        Try
            If m_blnVideoOpened Then
                txtOffset.Text = trcOffSet.Value
                AxFvxVideo1.SetVideoOffset(trcOffSet.Value)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'HWQlݒ
    Private Sub trcBinLevel_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcBinLevel.Scroll
        Try
            If m_blnVideoOpened And m_blnCanHWBinarize Then
                txtBinLevel.Text = trcBinLevel.Value
                AxFvxVideo1.SetBinarizeTheshold(trcBinLevel.Value)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'P荞
    Private Sub btn1Shot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn1Shot.Click

        Dim nHandle As Integer
        Dim dTime As Double

        Try
            nHandle = gridImageData.CurrentRow.Cells(0).Value
        Catch
            MsgBox("摜摜LockĂ܂B", vbExclamation, "G[")
            Exit Sub
        End Try

        If nHandle >= 1 Then
            Try
                AxFvxPerformanceCounter1.StartCount()
                'P荞
                AxFvxVideo1.ContinuousGrabEx(nHandle, 1, False)
                AxFvxPerformanceCounter1.StopCount(dTime)
            Catch
                Dim intErr As Integer
                'G[
                AxFvxVideo1.GetErrReport(intErr)
                MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
                Exit Sub
            End Try
            fnDispImage(fnFindHandleToIndex(nHandle), 0)
            txtGrabTime.Text = dTime.ToString("0.00ms")

            m_nIndexNo = fnFindHandleToIndex(nHandle)
            m_nLastNo = 0
        Else
            MsgBox("摜w肳Ă܂B", vbExclamation, "G[")
        End If
    End Sub

    '摜̕\
    Private Function fnDispImage(ByVal nIndexNo As Integer, ByVal nImageNo As Integer) As Integer

        Dim i As Integer
        If ((0 <= nIndexNo) And (nIndexNo < MAX_LOCK)) Then
            If nImageNo < m_ImgInfo(nIndexNo).iNum Then
                If (0 <= tab.SelectedIndex) And (tab.SelectedIndex <= 3) Then
                    If m_ImgInfo(nIndexNo).bImgCh(tab.SelectedIndex) = True Then
                        m_FvxImages(nIndexNo, tab.SelectedIndex).CurrentNo = nImageNo
                        m_AxFvxDisplayEx_CH(tab.SelectedIndex).DrawImage(m_FvxImages(nIndexNo, tab.SelectedIndex))
                        m_FvxImages(nIndexNo, tab.SelectedIndex).CurrentNo = 0
                    End If
                Else
                    For i = 0 To 4 - 1
                        If m_ImgInfo(nIndexNo).bImgCh(i) = True Then
                            m_FvxImages(nIndexNo, i).CurrentNo = nImageNo
                            m_AxFvxDisplayEx_ALL(i).DrawImage(m_FvxImages(nIndexNo, i))
                            m_FvxImages(nIndexNo, i).CurrentNo = 0
                        End If
                    Next i
                End If
            End If
        End If

    End Function

    '摜̃bN
    Private Sub btnImageLock_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImageLock.Click

        Dim no As Integer
        Dim nFBufChannel As Integer, nFBufNum As Integer

        no = fnFoundEmpty()
        If -1 <> no Then

            'p[^擾
            nFBufChannel = 0
            nFBufChannel = nFBufChannel * 2             'rbgVtg
            If chkInputChannel0.Checked = True Then nFBufChannel = nFBufChannel + 1
            nFBufChannel = nFBufChannel * 2             'rbgVtg
            If chkInputChannel1.Checked = True Then nFBufChannel = nFBufChannel + 1
            nFBufChannel = nFBufChannel * 2             'rbgVtg
            If chkInputChannel2.Checked = True Then nFBufChannel = nFBufChannel + 1
            nFBufChannel = nFBufChannel * 2             'rbgVtg
            If chkInputChannel3.Checked = True Then nFBufChannel = nFBufChannel + 1

            nFBufNum = udFBufNum.Value

            If True = fnCheckFBufConfigAndImageNum() Then

                'FBufConfig
                AxFvxVideo1.SetFBufConfig(nFBufChannel, nFBufNum)

                If chkInputChannel0.Checked Then
                    m_FvxImages(no, 0).ImageNum = udImageNum.Value
                    m_ImgInfo(no).bImgCh(0) = True
                Else
                    m_ImgInfo(no).bImgCh(0) = False
                End If
                If chkInputChannel1.Checked Then
                    m_FvxImages(no, 1).ImageNum = udImageNum.Value
                    m_ImgInfo(no).bImgCh(1) = True
                Else
                    m_ImgInfo(no).bImgCh(1) = False
                End If
                If chkInputChannel2.Checked Then
                    m_FvxImages(no, 2).ImageNum = udImageNum.Value
                    m_ImgInfo(no).bImgCh(2) = True
                Else
                    m_ImgInfo(no).bImgCh(2) = False
                End If
                If chkInputChannel3.Checked Then
                    m_FvxImages(no, 3).ImageNum = udImageNum.Value
                    m_ImgInfo(no).bImgCh(3) = True
                Else
                    m_ImgInfo(no).bImgCh(3) = False
                End If

                m_ImgInfo(no).bUsed = True
                m_ImgInfo(no).iNum = udImageNum.Value

                Try
                    '摜f[^Lock
                    m_ImgInfo(no).iHandle = AxFvxVideo1.ImageLock(fnIfImgOrNull(chkInputChannel0.Checked, m_FvxImages(no, 0)), _
                                                                    fnIfImgOrNull(chkInputChannel1.Checked, m_FvxImages(no, 1)), _
                                                                    fnIfImgOrNull(chkInputChannel2.Checked, m_FvxImages(no, 2)), _
                                                                    fnIfImgOrNull(chkInputChannel3.Checked, m_FvxImages(no, 3)))
                Catch
                    Dim intErr As Integer
                    'G[
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
                End Try

                'Xgr[ɏo
                fnAddData(no)
            Else
                MsgBox("ImageLocks摜́AFBufConfigŎw肵FVC05[Jobt@̉摜ȉł邩A" + vbCrLf + "܂́A{łKv܂BڂFvxHelpImageLock\bhQƂ", vbExclamation, "G[")
            End If
        Else
            MsgBox("̃AvP[Vł́Aő16܂łAbNł܂")
        End If

    End Sub

    'Xgr[Ƀf[^̒ǉ
    Private Function fnAddData(ByVal no As Long) As Integer
        Dim i As Integer

        If True = m_ImgInfo(no).bUsed Then
            i = gridImageData.Rows.Add()
            gridImageData.Rows(i).Cells(0).Value = m_ImgInfo(no).iHandle
            gridImageData.Rows(i).Cells(1).Value = m_ImgInfo(no).iNum
            gridImageData.Rows(i).Cells(2).Value = fn3op(m_ImgInfo(no).bImgCh(0), "", "-")
            gridImageData.Rows(i).Cells(3).Value = fn3op(m_ImgInfo(no).bImgCh(1), "", "-")
            gridImageData.Rows(i).Cells(4).Value = fn3op(m_ImgInfo(no).bImgCh(2), "", "-")
            gridImageData.Rows(i).Cells(5).Value = fn3op(m_ImgInfo(no).bImgCh(3), "", "-")

            gridImageData.CurrentCell = gridImageData.Rows(i).Cells(0)
        End If

        fnAddData = 0

    End Function

    Public Function fn3op(ByVal n As Boolean, ByVal a As Object, ByVal b As Object) As Object
        If True = n Then
            fn3op = a
        Else
            fn3op = b
        End If
    End Function

    'n`FbNAFvxImageNULLԂ
    Private Function fnIfImgOrNull(ByVal n As Boolean, ByRef a As FVXCOMIMAGELib.FvxImage) As FVXCOMIMAGELib.FvxImage
        If True = n Then
            fnIfImgOrNull = a
        Else
            fnIfImgOrNull = Nothing
        End If
    End Function

    '[Jobt@TCYImageLock̉摜֌W`FbN
    Private Function fnCheckFBufConfigAndImageNum() As Boolean
        Dim nImageNum As Integer
        Dim nFBufNum As Integer
        Dim bStatus As Integer

        nFBufNum = udFBufNum.Value
        nImageNum = udImageNum.Value

        bStatus = True
        If ((nImageNum > nFBufNum) And (0 <> (nImageNum Mod nFBufNum))) Then
            bStatus = False
        End If

        fnCheckFBufConfigAndImageNum = bStatus
    End Function

    '摜f[^A󂢂ĂꏊT
    Private Function fnFoundEmpty() As Integer

        Dim i As Integer

        For i = 0 To MAX_LOCK - 1
            If False = m_ImgInfo(i).bUsed Then
                Exit For
            End If
        Next i

        If i <> MAX_LOCK Then
            fnFoundEmpty = i
        Else
            fnFoundEmpty = -1
        End If

    End Function

    'FBufConfig̍őTCYvZ & FBufConfigImageLock̉摜̊֌W`FbN
    Private Sub fnCalcFBufMaxNum()

        Dim nTmpNum As Long
        Dim nFrameSize As Long, nFrameSize2 As Long
        Dim nSize As Long
        Dim i As Long
        Dim pSize As New FvSize
        Dim nFBufNum As Long
        Dim nMaxNum As Long
        Dim bLockButtonStatus As Boolean
        Dim nLockImageNum As Long

        'FBufConfig̃`FbN{bNX0̏ꍇ͌vZoȂ߁A֐甲
        If (chkInputChannel0.Checked = False) And (chkInputChannel1.Checked = False) And _
                (chkInputChannel2.Checked = False) And (chkInputChannel3.Checked = False) Then
            txtMaxNum.Text = "---"
            udFBufNum.BackColor = Color.Red
            udFBufNum.ForeColor = Color.White
            btnImageLock.Enabled = False

            Exit Sub
        End If

        '
        nFrameSize2 = 0

        AxFvxVideo1.GetCaptureSize(pSize)
        nFrameSize = pSize.x * pSize.y
        If chkInputChannel0.Checked = True Then nFrameSize2 = nFrameSize2 + nFrameSize
        If chkInputChannel1.Checked = True Then nFrameSize2 = nFrameSize2 + nFrameSize
        If chkInputChannel2.Checked = True Then nFrameSize2 = nFrameSize2 + nFrameSize / 8
        If chkInputChannel3.Checked = True Then nFrameSize2 = nFrameSize2 + nFrameSize / 8

        '256kEꍇ̍ő喇vZ
        nTmpNum = Int(FVC05_LOCAL_BUFFER_SIZE / nFrameSize2)

        '256kE̖ꍇ̖A256kEꍇ̍ő喇JԂpĎZo
        For i = nTmpNum To 0 Step -1
            nSize = 0
            If chkInputChannel0.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * i)
            If chkInputChannel1.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * i)
            If chkInputChannel2.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * i / 8)
            If chkInputChannel3.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * i / 8)
            If nSize <= FVC05_LOCAL_BUFFER_SIZE Then
                nMaxNum = i
                Exit For
            End If
        Next i
        txtMaxNum.Text = nMaxNum.ToString

        'SetFBufConfig ݂̐ݒ肪ǂAAԂŕ\
        nSize = 0
        nFBufNum = udFBufNum.Value
        If chkInputChannel0.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * nFBufNum)
        If chkInputChannel1.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * nFBufNum)
        If chkInputChannel2.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * nFBufNum / 8)
        If chkInputChannel3.Checked = True Then nSize = nSize + fn256kBoundary(nFrameSize * nFBufNum / 8)

        bLockButtonStatus = True
        If nSize <= FVC05_LOCAL_BUFFER_SIZE Then   'FVC05̓[Jobt@TCY
            udFBufNum.BackColor = Color.Blue
            udFBufNum.ForeColor = Color.White
        Else
            udFBufNum.BackColor = Color.Red
            udFBufNum.ForeColor = Color.White
            bLockButtonStatus = False
        End If

        'SetFBufConfig̒lImageLock̊֌W`FbNAEԂ
        nLockImageNum = udImageNum.Value
        If (nLockImageNum <= nFBufNum) Or (0 = nLockImageNum Mod nFBufNum) Then
            udImageNum.BackColor = Color.Blue
            udImageNum.ForeColor = Color.White
        Else
            udImageNum.BackColor = Color.Red
            udImageNum.ForeColor = Color.White
            bLockButtonStatus = False
        End If

        'ImageLock{^Enable
        btnImageLock.Enabled = bLockButtonStatus

    End Sub

    'TCY256k̒Pʂɕϊ
    Private Function fn256kBoundary(ByVal nSize As Integer) As Integer

        If 0 = (nSize And CONST_BUFF_MASK) Then
            fn256kBoundary = nSize
        Else
            fn256kBoundary = (nSize And (Not CONST_BUFF_MASK)) + CONST_BUFF_BOUNDARY
        End If

    End Function

    '̓`l`FbN{bNX̃NbN
    Private Sub chkInputChannel0_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkInputChannel0.CheckedChanged
        fnCalcFBufMaxNum()
    End Sub

    '̓`l`FbN{bNX̃NbN
    Private Sub chkInputChannel1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkInputChannel1.CheckedChanged
        fnCalcFBufMaxNum()
    End Sub

    '̓`l`FbN{bNX̃NbN
    Private Sub chkInputChannel2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkInputChannel2.CheckedChanged
        fnCalcFBufMaxNum()
    End Sub

    '̓`l`FbN{bNX̃NbN
    Private Sub chkInputChannel3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkInputChannel3.CheckedChanged
        fnCalcFBufMaxNum()
    End Sub


    'TabύX
    Private Sub tab_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tab.SelectedIndexChanged

        fnDispImage(m_nIndexNo, m_nLastNo)

    End Sub

    Private Sub gridImageData_CellMouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles gridImageData.CellMouseUp

        'Xgr[ENbN - ImageUnlock
        If e.Button = Windows.Forms.MouseButtons.Right Then

            Dim nHandle As Long
            Dim nStatus As Long
            Try
                nHandle = gridImageData.CurrentRow.Cells(0).Value
            Catch
                Exit Sub
            End Try
            If (False = m_bIsContinuous) Or (m_nIndexNo <> fnFindHandleToIndex(nHandle)) Then
                nStatus = MsgBox("Handle=" + nHandle.ToString + "AAbN܂H", vbOKCancel, "mF")
                If vbOK = nStatus Then
                    AxFvxVideo1.ImageUnlock(nHandle)
                    fnInitImgInfo(fnFindHandleToIndex(nHandle))
                    gridImageData.Rows.Remove(gridImageData.CurrentRow)
                End If
            End If

        End If

    End Sub

    '^C}[iA荞݁j
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim nTotal As Integer, nAmount As Integer, nLast As Integer

        Timer1.Stop()

        Try

            'ݎ荞܂Ă摜ԍ擾
            AxFvxVideo1.NotifyCaptureNo(nTotal, nAmount, nLast)
            '摜̕\
            fnDispImage(m_nIndexNo, nLast.ToString)
            'g[^̕\
            txtTotalCount.Text = nTotal.ToString

            m_nLastNo = nLast

            'w莞Ŏ荞݊ԂɂȂꍇAI
            If AxFvxVideo1.GrabASyncStatus2 = FVXCOMVIDEOLib.FVX_VIDEO_GRAB_STATUS.videoGrabCompleted Then
                AxFvxVideo1.GrabASyncStatus()
                m_bIsContinuous = False
                fnButtonEnable(True)
                Timer1.Enabled = False
                btnContinuousGrabEx.Text = "A荞݊Jn"
            Else
                Timer1.Enabled = True
            End If
        Catch

            Dim iErr As Integer
            AxFvxVideo1.GetErrReport(iErr)
            AxFvxVideo1.GrabCancel(0)
            m_bIsContinuous = False
            fnButtonEnable(True)
            Timer1.Enabled = False
            btnContinuousGrabEx.Text = "A荞݊Jn"

            MsgBox("荞݃G[܂ : ErrorCode=" + iErr.ToString, vbExclamation, "Error")

        End Try

    End Sub

    'w摜\
    Private Sub btnDisp0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisp0.Click

        m_nDispNo = m_nDispNo - 1

        Dim nHandle As Integer, nIndexNo As Integer
        Try
            nHandle = gridImageData.CurrentRow.Cells(0).Value
        Catch
            Exit Sub
        End Try
        nIndexNo = fnFindHandleToIndex(nHandle)

        If m_nDispNo < 0 Then
            m_nDispNo = m_ImgInfo(nIndexNo).iNum - 1
        ElseIf m_nDispNo >= m_ImgInfo(nIndexNo).iNum Then
            m_nDispNo = 0
        End If

        fnDispImage(nIndexNo, m_nDispNo)
        txtDispNo.Text = m_nDispNo.ToString

    End Sub

    'w摜\
    Private Sub btnDisp1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisp1.Click

        m_nDispNo = m_nDispNo + 1

        Dim nHandle As Integer, nIndexNo As Integer
        Try
            nHandle = gridImageData.CurrentRow.Cells(0).Value
        Catch
            Exit Sub
        End Try
        nIndexNo = fnFindHandleToIndex(nHandle)

        If m_nDispNo < 0 Then
            m_nDispNo = m_ImgInfo(nIndexNo).iNum - 1
        ElseIf m_nDispNo >= m_ImgInfo(nIndexNo).iNum Then
            m_nDispNo = 0
        End If

        fnDispImage(nIndexNo, m_nDispNo)
        txtDispNo.Text = m_nDispNo.ToString

    End Sub

    'FBufConfig̖ݒύX
    Private Sub udFBufNum_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles udFBufNum.ValueChanged
        fnCalcFBufMaxNum()
    End Sub

    'ImageLock̐ݒ薇ύX
    Private Sub udImageNum_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles udImageNum.ValueChanged
        fnCalcFBufMaxNum()
    End Sub
End Class
